
-- sorry, monks only
if select(2, UnitClass("player")) ~= "MONK" then
    return
end

local locDB = ChiEnergyBar.locDB

---------------------------------------------------------------------------------------------
-------------------------[[ functions  ]]----------------------------------------------------
---------------------------------------------------------------------------------------------

function ChiEnergyBar:UpdateEnergy()

	local enCur = UnitPower("player", 3)
	local enMax = UnitPowerMax("player", 3)
	local cpCur = UnitPower("player", 12)
	local _, _, _, tbCur = UnitBuff("player", locDB.tBrew)
	return enCur, enMax, cpCur, tbCur

end

function ChiEnergyBar:UpdateBar()

	local enCur, _, cpCur, tbCur = ChiEnergyBar:UpdateEnergy()
	local ebStatusBar, ebBarTxt, tbBarTxt = EnergyStatusBar, EnergyBarText, TBBarText
	local cpFrame = "CPFrame"
	if TBBar:IsVisible() then
 		if tbCur and tbCur > 0 then
			tbBarTxt:SetText(tbCur)
		else
			tbBarTxt:SetText(nil)
		end
	end
	if EnergyBar:IsVisible() then
		ebStatusBar:SetValue(enCur)
		local energyStr = ChiEnergyBar:GetEnergyString()
		ebBarTxt:SetText(energyStr)
	end
-- print("locDB.doChiPointsUpdate = "..tostring(locDB.doChiPointsUpdate))
	if locDB.doChiPointsUpdate then
		if locDB.cpUpdate or cpCur ~= locDB.cpOld then
			if locDB.cpUpdate then
				locDB.cpUpdate = false
			end
			local bg = {
				bgFile = ChiEnergyBarDB.cp.texture.path,
				edgeFile = ChiEnergyBarDB.cp.border.path,
				tile = false,
				tileSize = 8,
				edgeSize = ChiEnergyBarDB.cp.border.edgeSize,
				insets = {
					left = 3,
					right = 3,
					top = 3,
					bottom = 3,
				}
			}
			if ChiEnergyBarDB.cpShowAllways then
				for i = 1, cpCur do
					local fr = cpFrame..i
					local cpFr = _G[fr]
					cpFr:SetBackdrop(bg)
					cpFr:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
					cpFr:Show()
				end
				for i = cpCur + 1, locDB.cpMax do
					local fr = cpFrame..i
					local cpFr = _G[fr]
					if not ChiEnergyBarDB.cpShowAllwaysWithTexture then
						if ChiEnergyBarDB.cp.border.txt == locDB.border[1].txt then
							bg.bgFile = "Interface\\Tooltips\\UI-Tooltip-Background"
						else
							bg.bgFile = nil
						end
					else
						bg.bgFile = ChiEnergyBarDB.cp.texture.path
					end
					cpFr:SetBackdrop(bg)
					cpFr:Show()
				end
				if _G[cpFrame..(locDB.cpMax + 1)] then
					_G[cpFrame..(locDB.cpMax + 1)]:Hide()
				end
			else
				for i = 1, cpCur do
					local fr = cpFrame..i
					local cpFr = _G[fr]
					cpFr:SetBackdrop(bg)
					cpFr:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
					cpFr:Show()
				end
				for i = cpCur + 1, locDB.cpMax do
					local fr = cpFrame..i
					local cpFr = _G[fr]
					cpFr:Hide()
				end
			end
			locDB.cpOld = cpCur
			CEBCoreFrame:SetScript("OnUpdate", ChiEnergyBar.OnUpdate)
		end
	end

end

function ChiEnergyBar:CreateFrames()

	ChiEnergyBar:CreateFrame("EnergyBar")
	ChiEnergyBar:CreateFrame("ChiPointsBar")
	ChiEnergyBar:CreateFrame("TBBar")

end

function ChiEnergyBar:PlayerLogin()

	locDB.cpMax = UnitPowerMax("player", 12)
	ChiEnergyBar:LoadDefault()
	ChiEnergyBar:InitializeSlashHandler()
	ChiEnergyBar:CreateFrames()
	ChiEnergyBar:CreateOptionsPanel()
	ChiEnergyBar:CreateChiPointsBar()
	ChiEnergyBar:CreateEnergyBar()
	ChiEnergyBar:CreateTigereyeBrewFrame()
	ChiEnergyBar:UpdateBar()
	if not ChiEnergyBarDB.noHelpText then
		ChiEnergyBar:CreateHelpFrame()
	end

end

function ChiEnergyBar.OnUpdate(self, elapsed)

	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	while (self.TimeSinceLastUpdate > self.updateInterval) do
		ChiEnergyBar:UpdateBar()
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - self.updateInterval
	end

end

---------------------------------------------------------------------------------------------
--------------------------[[  Slashcommands  ]]----------------------------------------------
---------------------------------------------------------------------------------------------

function ChiEnergyBar:InitializeSlashHandler()

	SLASH_ChiEnergyBar1 = "/ceb"
	SLASH_ChiEnergyBar2 = "/ceb ebtoggle"
	SLASH_ChiEnergyBar3 = "/ceb cptoggle"
	SLASH_ChiEnergyBar4 = "/ceb tbtoggle"
	SLASH_ChiEnergyBar5 = "/ceb default"
	local function slHandler(msg, editbox)
		if msg == "ebtoggle" then
			ChiEnergyBar:BarLockToggle("eb")
		elseif msg == "cptoggle" then
			ChiEnergyBar:BarLockToggle("cp")
		elseif msg == "tbtoggle" then
			ChiEnergyBar:BarLockToggle("tb")
		elseif msg == "default" then
			ChiEnergyBar:ResetToDefaultValues()
		else
			InterfaceOptionsFrame_OpenToCategory(ChiEnergyBar_Panel)
		end
	end
	SlashCmdList.ChiEnergyBar = slHandler

end

---------------------------------------------------------------------------------------------
--------------------------[[  Register events  ]] -------------------------------------------
---------------------------------------------------------------------------------------------

--  create coreframe to register and watch events
if not CEBCoreFrame then

	local cebCoreFr = ChiEnergyBar:CreateFrame("CEBCoreFrame")
	cebCoreFr.updateInterval = 0.1
	cebCoreFr.TimeSinceLastUpdate = 0

end

local function RegEventsHandler(self, event, ...)

	if event == "PLAYER_LOGIN" then
		ChiEnergyBar:PlayerLogin()
		ChiEnergyBar.eventHandler:UnregisterEvent("PLAYER_LOGIN")
		ChiEnergyBar.eventHandler:RegisterEvent("PLAYER_TALENT_UPDATE")
		ChiEnergyBar.eventHandler:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	elseif  event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED" then
		ChiEnergyBar:UpdateBar()
		if ChiEnergyBarDB.ebEnable then
			if ChiEnergyBarDB.ebShowOnlyInCombat then
				if UnitAffectingCombat("player") then
					-- in combat
					locDB.inCombat = true
					EnergyBar:Show()
				else
					-- not in combat
					locDB.inCombat = false
					EnergyBar:Hide()
				end
			end
		end
		if ChiEnergyBarDB.cpEnable then
			if ChiEnergyBarDB.cpShowOnlyInCombat then
				if UnitAffectingCombat("player") then
					-- in combat
					locDB.inCombat = true
					ChiPointsBar:Show()
				else
					-- not in combat
					locDB.inCombat = false
					ChiPointsBar:Hide()
				end
			end
		end
		if ChiEnergyBarDB.tbEnable then
			if ChiEnergyBarDB.tbShowOnlyInCombat then
				if UnitAffectingCombat("player") then
					-- in combat
					locDB.inCombat = true
					TBBar:Show()
				else
					-- not in combat
					locDB.inCombat = false
					TBBar:Hide()
				end
			end
		end
	elseif event == "UNIT_ENTERED_VEHICLE" then
		ChiEnergyBar.eventHandler:UnregisterEvent("UNIT_ENTERED_VEHICLE")
		ChiEnergyBar.eventHandler:RegisterEvent("UNIT_EXITED_VEHICLE")
		local unit = select(1, ...)
		if unit == "player" then
			local inVehicle, hasVehicleUI = UnitInVehicle(unit), UnitHasVehicleUI(unit)
			if inVehicle and hasVehicleUI then
				EnergyBar:Hide()
				ChiPointsBar:Hide()
				TBBar:Hide()
			end
		end
	elseif event == "UNIT_EXITED_VEHICLE" then
		ChiEnergyBar.eventHandler:UnregisterEvent("UNIT_EXITED_VEHICLE")
		ChiEnergyBar.eventHandler:RegisterEvent("UNIT_ENTERED_VEHICLE")
		ChiEnergyBar:UpdateBar()
		local unit = select(1, ...)
		if unit == "player" then
			ChiEnergyBar:UpdateBar()
			if ChiEnergyBarDB.ebEnable then
				if ChiEnergyBarDB.ebShowOnlyInCombat then
					EnergyBar:Hide()
				else
					EnergyBar:Show()
				end
			else
				Energybar:Hide()
			end
			if ChiEnergyBarDB.cpEnable then
				if ChiEnergyBarDB.cpShowOnlyInCombat then
					ChiPointsBar:Hide()
				else
					ChiPointsBar:Show()
				end
			else
				ChiPointsBar:Hide()
			end
			if ChiEnergyBarDB.tbEnable then
				if ChiEnergyBarDB.tbShowOnlyInCombat then
					TBBar:Hide()
				else
					TBBar:Show()
				end
			else
				TBBar:Show()
			end
		end
	elseif event == "PET_BATTLE_OPENING_START" then
		ChiEnergyBar.eventHandler:UnregisterEvent("PET_BATTLE_OPENING_START")
		ChiEnergyBar.eventHandler:RegisterEvent("PET_BATTLE_CLOSE")
		EnergyBar:Hide()
		ChiPointsBar:Hide()
		TBBar:Hide()
	elseif event == "PLAYER_ENTERING_WORLD" or event == "PET_BATTLE_CLOSE" then
		if event == "PET_BATTLE_CLOSE" then
			ChiEnergyBar.eventHandler:UnregisterEvent("PET_BATTLE_CLOSE")
			ChiEnergyBar.eventHandler:RegisterEvent("PET_BATTLE_OPENING_START")
		end
		ChiEnergyBar:UpdateBar()
		if ChiEnergyBarDB.ebEnable then
			if ChiEnergyBarDB.ebShowOnlyInCombat then
				EnergyBar:Hide()
			else
				EnergyBar:Show()
			end
		else
			EnergyBar:Hide()
		end
		if ChiEnergyBarDB.cpEnable then
			if ChiEnergyBarDB.cpShowOnlyInCombat then
				ChiPointsBar:Hide()
			else
				ChiPointsBar:Show()
			end
		else
			ChiPointsBar:Hide()
		end
		if ChiEnergyBarDB.tbEnable then
			if ChiEnergyBarDB.tbShowOnlyInCombat then
				TBBar:Hide()
			else
				TBBar:Show()
			end
		else
			TBBar:Hide()
		end
	elseif event == "PLAYER_TALENT_UPDATE" or event == "ACTIVE_TALENT_GROUP_CHANGED" then
		local _, _, _, _, _, hasAscension = GetTalentInfo(8)
		if hasAscension then
			locDB.cpMax = locDB.cpTot
		else
			locDB.cpMax = locDB.cpTot - 1
		end
		locDB.cpUpdate = true
		locDB.doChiPointsUpdate = true
		ChiEnergyBar:HandleChiPointFrames(locDB.cpMax, true)
		ChiEnergyBar:UpdateBar()
	elseif event == "UNIT_POWER" or event == "UNIT_AURA" then
		local unit = select(1, ...)
		if unit == "player" then
			ChiEnergyBar:UpdateBar()
		end
	end

end

function ChiEnergyBar:RegEvents()

	ChiEnergyBar.eventHandler = CEBCoreFrame
	ChiEnergyBar.eventHandler:RegisterEvent("PLAYER_LOGIN")
	ChiEnergyBar.eventHandler:RegisterEvent("PLAYER_ENTERING_WORLD")
	ChiEnergyBar.eventHandler:RegisterEvent("PLAYER_REGEN_DISABLED")
	ChiEnergyBar.eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	ChiEnergyBar.eventHandler:RegisterEvent("UNIT_POWER")
	ChiEnergyBar.eventHandler:RegisterEvent("UNIT_AURA")
	ChiEnergyBar.eventHandler:RegisterEvent("UNIT_ENTERED_VEHICLE")
	ChiEnergyBar.eventHandler:RegisterEvent("PET_BATTLE_OPENING_START")
	ChiEnergyBar.eventHandler:SetScript("OnEvent", RegEventsHandler)

end

ChiEnergyBar:RegEvents()


