
-- sorry, monks only
if select(2, UnitClass("player")) ~= "MONK" then
    return
end

---------------------------------------------------------------------------------------------
-------------------------[[  local variables  ]]---------------------------------------------
---------------------------------------------------------------------------------------------

-- create local namespace
local ChiEnergyBar = {}
_G.ChiEnergyBar = ChiEnergyBar

local version = GetAddOnMetadata("ChiEnergyBar", "Version")
local texturePath = "Interface\\AddOns\\ChiEnergyBar\\SharedMedia\\"
local locDB = {
	doChiPointsUpdate = true,
	cpUpdate = false,
	cpMax = UnitPowerMax("player", 12),
	cpTot = 5,
	xSized = false,
	ySized = false,
	inVehicle = false,
	inCombat = false,
	tBrew = GetSpellInfo(116740),    -- 116740 = spellID of Tigereye Brew
	cpOld = 0,
	border = {
		{path = nil, txt = "No border", edgeSize = 0, adjW = 4, adjH = 4},
		{path = "Interface\\Tooltips\\UI-Tooltip-Border", txt = "Tooltip thin", edgeSize = 10, adjW = 4, adjH = 4},
		{path = "Interface\\Tooltips\\UI-Tooltip-Border", txt = "Tooltip thick", edgeSize = 18, adjW = 7, adjH = 7},
		{path = "Interface\\DialogFrame\\UI-DialogBox-Border", txt = "Dialog thin", edgeSize = 10, adjW =7,  adjH =7},
		{path = "Interface\\DialogFrame\\UI-DialogBox-Border", txt = "Dialog thick", edgeSize = 16, adjW =7,  adjH =7},
		{path = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", txt = "DialogGold thin", edgeSize = 10, adjW = 7, adjH = 7},
		{path = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", txt = "DialogGold thick", edgeSize = 16, adjW = 7, adjH = 7},
		{path = "Interface\\AchievementFrame\\UI-Achievement-WoodBorder", txt = "Wood thin", edgeSize = 10, adjW = 7, adjH = 7},
		{path = "Interface\\AchievementFrame\\UI-Achievement-WoodBorder", txt = "Wood thick", edgeSize = 16, adjW = 7, adjH = 7},
	},
	texture = {
		{path = texturePath.."background\\moo.tga",  txt = "Moo"},
		{path = texturePath.."background\\bricks.tga", txt = "Bricks"},
		{path = texturePath.."background\\brushedmetal.tga", txt = "Brushed Metal"},
		{path = texturePath.."background\\copper.tga", txt = "Copper"},
		{path = texturePath.."background\\smoke.tga", txt =  "Smoke"},
		{path = texturePath.."statusbar\\Aluminium", txt =  "Aluminium"},
		{path = texturePath.."statusbar\\Armory", txt = "Armory"},
		{path = texturePath.."statusbar\\BantoBar",txt = "BantoBar"},
		{path = texturePath.."statusbar\\Bars", txt = "Bars"},
		{path = texturePath.."statusbar\\Bumps", txt = "Bumps"},
		{path = texturePath.."statusbar\\Button", txt = "Button"},
		{path = texturePath.."statusbar\\Charcoal", txt = "Charcoal"},
		{path = texturePath.."statusbar\\Cilo", txt = "Cilo"},
		{path = texturePath.."statusbar\\Cloud", txt = "Cloud"},
		{path = texturePath.."statusbar\\Comet", txt = "Comet"},
		{path = texturePath.."statusbar\\Dabs", txt = "Dabs"},
		{path = texturePath.."statusbar\\DarkBottom", txt = "DarkBottom"},
		{path = texturePath.."statusbar\\Diagonal", txt = "Diagonal"},
		{path = texturePath.."statusbar\\Falumn", txt = "Falumn"},
		{path = texturePath.."statusbar\\Fifths", txt = "Fifths"},
		{path = texturePath.."statusbar\\Flat", txt = "Flat"},
		{path = texturePath.."statusbar\\Fourths", txt = "Fourths"},
		{path = texturePath.."statusbar\\Frost", txt = "Frost"},
		{path = texturePath.."statusbar\\Glamour", txt = "Glamour"},
		{path = texturePath.."statusbar\\Glamour2", txt = "Glamour2"},
		{path = texturePath.."statusbar\\Glamour3", txt = "Glamour3"},
		{path = texturePath.."statusbar\\Glamour4", txt = "Glamour4"},
		{path = texturePath.."statusbar\\Glamour5", txt = "Glamour5"},
		{path = texturePath.."statusbar\\Glamour6", txt = "Glamour6"},
		{path = texturePath.."statusbar\\Glamour7", txt = "Glamour7"},
		{path = texturePath.."statusbar\\Glass", txt = "Glass"},
		{path = texturePath.."statusbar\\Glaze", txt = "Glaze"},
		{path = texturePath.."statusbar\\Glaze2", txt = "Glaze v2"},
		{path = texturePath.."statusbar\\Gloss", txt = "Gloss"},
		{path = texturePath.."statusbar\\Graphite", txt = "Graphite"},
		{path = texturePath.."statusbar\\Grid", txt = "Grid"},
		{path = texturePath.."statusbar\\Hatched", txt = "Hatched"},
		{path = texturePath.."statusbar\\Healbot", txt = "Healbot"},
		{path = texturePath.."statusbar\\Lyfe", txt = "Lyfe"},
		{path = texturePath.."statusbar\\LiteStep", txt = "LiteStep"},
		{path = texturePath.."statusbar\\LiteStepLite", txt = "LiteStepLite"},
		{path = texturePath.."statusbar\\Melli", txt = "Melli"},
		{path = texturePath.."statusbar\\MelliDark", txt = "Melli Dark"},
		{path = texturePath.."statusbar\\MelliDarkRough", txt = "Melli Dark Rough"},
		{path = texturePath.."statusbar\\Minimalist", txt = "Minimalist"},
		{path = texturePath.."statusbar\\Otravi", txt = "Otravi"},
		{path = texturePath.."statusbar\\Outline", txt = "Outline"},
		{path = texturePath.."statusbar\\Perl", txt = "Perl"},
		{path = texturePath.."statusbar\\Perl2", txt = "Perl v2"},
		{path = texturePath.."statusbar\\Pill", txt = "Pill"},
		{path = "Interface\\RaidFrame\\Raid-Bar-Hp-Fill", txt = "Raid bar"},
		{path = texturePath.."statusbar\\Rain", txt = "Rain"},
		{path = texturePath.."statusbar\\Rocks", txt = "Rocks"},
		{path = texturePath.."statusbar\\Round", txt = "Round"},
		{path = texturePath.."statusbar\\Ruben", txt = "Ruben"},
		{path = texturePath.."statusbar\\Runes", txt = "Runes"},
		{path = texturePath.."statusbar\\SemiWhite", txt = "Semi transparent"},
		{path = texturePath.."statusbar\\Skewed", txt = "Skewed"},
		{path = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar", txt = "Skills bar"},
		{path = texturePath.."statusbar\\Smooth", txt = "Smooth"},
		{path = texturePath.."statusbar\\Smoothv2", txt = "Smooth v2"},
		{path = texturePath.."statusbar\\Smudge", txt = "Smudge"},
		{path = "Interface\\TargetingFrame\\UI-StatusBar", txt = "Statusbar"},
		{path = texturePath.."statusbar\\Steel", txt = "Steel"},
		{path = texturePath.."statusbar\\Striped", txt = "Striped"},
		{path = texturePath.."statusbar\\TransWhite", txt = "Transparent"},
		{path = texturePath.."statusbar\\Tube", txt = "Tube"},
		{path = texturePath.."statusbar\\Water", txt = "Water"},
		{path = texturePath.."statusbar\\Wglass", txt = "Wglass"},
		{path = texturePath.."statusbar\\Wisps", txt = "Wisps"},
		{path = texturePath.."statusbar\\Xeon", txt = "Xeon"},
	},
	font = {
		{path = "Fonts\\ARIALN.TTF", txt = "ArialN"},
		{path = "Fonts\\FRIZQT__.TTF", txt = "FRIZQT"},
		{path = "Fonts\\MORPHEUS.ttf", txt = "MORPHEUS"},
		{path = "Fonts\\skurri.ttf", txt = "Skurri"},
	},
	fontSetPoints = {
		{setPoint = "LEFT", hPadding = 4, txt = "Left"},
		{setPoint = "CENTER", hPadding = 0, txt = "Center"},
		{setPoint = "RIGHT", hPadding = -4, txt = "Right"},
	},
	colPickId = "Eb",
	color = {
		-- default chi points color
		cp = {
			r = 0.5098039215686275,
			g = 0.8313725490196078,
			b = 0.7215686274509804,
			a = 1,
		},
		-- default energybar color
		eb = {
			r = 1,
			g = 1,
			b = 0,
			a = 1,
		},
		blizzYellow = {
			r = 1,
			g = 0.8196079,
			b = 0,
			a = 1,
		},
		orangeRed = {
			r = 1,
			g = 0.27,
			b = 0,
			a = 1,
		},
	},
	helpText = {
		tabSpace = "                             ",
		title = "|cffff4500ChiEnergyBar "..version.." - first time user help|r|n",
		line1 = "|nTo move or customize the chi points and/or energy bar you have to unlock the bar(s) first.",
		line2 = "|nYou can do this trough the options panel.|n|n",
		slashCom = "  - Slashcommands: \"/ceb\" open options panel|n",
		toggle1 = "\"/ceb ebtoggle\" lock/unlock energy bar|n",
		toggle2 = "\"/ceb cptoggle\" lock/unlock chi points bar|n",
		toggle3 = "\"/ceb default\" Reset to default values and reload UI|n",
		mouse1 = "|n  - Left mouse button: move bar",
		mouse2 = "|n  - Right mouse button: size bar",
		mouse3 = "|n  - Shift + Left mouse button: lock/unlock bar|n",
	},
}
ChiEnergyBar.locDB = locDB           -- make locDB available for all CEB scripts

---------------------------------------------------------------------------------------------
--------------------------[[  Default settings  ]]-------------------------------------------
---------------------------------------------------------------------------------------------

-- making sure everything needed gets loaded on login
function ChiEnergyBar:LoadDefault()

	if not ChiEnergyBarDB then ChiEnergyBarDB = {} end
	if not ChiEnergyBarDB.noHelpText then ChiEnergyBarDB.noHelpText = false end
	if not ChiEnergyBarDB.eb then ChiEnergyBarDB.eb = {} end
	if not ChiEnergyBarDB.eb.coords then ChiEnergyBarDB.eb.coords = {} end
	if not ChiEnergyBarDB.eb.border then ChiEnergyBarDB.eb.border = {path = "Interface\\Tooltips\\UI-Tooltip-Border", txt = "Tooltip thin", edgeSize = 10, adjW = 4, adjH = 4} end
	if not ChiEnergyBarDB.eb.font then ChiEnergyBarDB.eb.font = {path = "Fonts\\ARIALN.TTF", txt = "ArialN", height = 14} end
	if not ChiEnergyBarDB.eb.fontSetPoints then ChiEnergyBarDB.eb.fontSetPoints = {setPoint = "CENTER", hPadding = 0, txt = "Center"} end
	if not ChiEnergyBarDB.eb.texture then ChiEnergyBarDB.eb.texture = {path = "Interface\\TargetingFrame\\UI-StatusBar", txt = "Statusbar"} end
	if not ChiEnergyBarDB.eb.size then ChiEnergyBarDB.eb.size = {w = 150, h = 20} end
	if not ChiEnergyBarDB.eb.color then ChiEnergyBarDB.eb.color = {r = locDB.color.eb.r, g = locDB.color.eb.g, b = locDB.color.eb.b, a = locDB.color.eb.a} end
	if not ChiEnergyBarDB.ebShowEnergy then ChiEnergyBarDB.ebShowEnergy = false end
	if not ChiEnergyBarDB.ebNoMaxEnergy then ChiEnergyBarDB.ebNoMaxEnergy = false end
	if not ChiEnergyBarDB.cp then ChiEnergyBarDB.cp = {} end
	if not ChiEnergyBarDB.cp.coords then ChiEnergyBarDB.cp.coords = {} end
	if not ChiEnergyBarDB.cp.border then ChiEnergyBarDB.cp.border = {path = "Interface\\Tooltips\\UI-Tooltip-Border", txt = "Tooltip thin", edgeSize = 14, adjW = 7, adjH = 5} end
	if not ChiEnergyBarDB.cp.texture then ChiEnergyBarDB.cp.texture = {path = "Interface\\TargetingFrame\\UI-StatusBar", txt = "Statusbar"} end
	if not ChiEnergyBarDB.cp.size then ChiEnergyBarDB.cp.size = {w = 150, h = 20} end
	if not ChiEnergyBarDB.cp.spacing then ChiEnergyBarDB.cp.spacing = 0 end
	if not ChiEnergyBarDB.cp.color then ChiEnergyBarDB.cp.color = {r = locDB.color.cp.r, g = locDB.color.cp.g, b = locDB.color.cp.b, a = locDB.color.cp.a} end
	if not ChiEnergyBarDB.tb then ChiEnergyBarDB.tb = {} end
	if not ChiEnergyBarDB.tb.coords then ChiEnergyBarDB.tb.coords = {} end
	if not ChiEnergyBarDB.tb.border then ChiEnergyBarDB.tb.border = {path = nil, txt = nil, edgeSize = 0, adjW = 0, adjH = 0} end
	if not ChiEnergyBarDB.tb.font then ChiEnergyBarDB.tb.font = {path = "Fonts\\ARIALN.TTF", txt = "ArialN", height = 28} end
	if not ChiEnergyBarDB.tb.size then ChiEnergyBarDB.tb.size = {w = 32, h = 32} end
 	if type(ChiEnergyBarDB.ebEnable) ~= "boolean"  then ChiEnergyBarDB.ebEnable = true end
	if type(ChiEnergyBarDB.cpEnable) ~= "boolean" then ChiEnergyBarDB.cpEnable = true end
	if type(ChiEnergyBarDB.tbEnable) ~= "boolean" then ChiEnergyBarDB.tbEnable = true end
	if type(ChiEnergyBarDB.ebLock) ~= "boolean" then ChiEnergyBarDB.ebLock = true end
	if type(ChiEnergyBarDB.cpLock) ~= "boolean" then ChiEnergyBarDB.cpLock = true end
	if type(ChiEnergyBarDB.tbLock) ~= "boolean" then ChiEnergyBarDB.tbLock = true end
	if not ChiEnergyBarDB.ebShowOnlyInCombat then ChiEnergyBarDB.ebShowOnlyInCombat = false end
	if not ChiEnergyBarDB.cpShowOnlyInCombat then ChiEnergyBarDB.cpShowOnlyInCombat = false end
	if not ChiEnergyBarDB.tbShowOnlyInCombat then ChiEnergyBarDB.tbShowOnlyInCombat = false end
	if type(ChiEnergyBarDB.cpShowAllways) ~= "boolean" then ChiEnergyBarDB.cpShowAllways = true end
	if not ChiEnergyBarDB.cpShowAllwaysWithTexture then ChiEnergyBarDB.cpShowAllwaysWithTexture = false end

end

if not ChiEnergyBarDB then

	ChiEnergyBar:LoadDefault()

end

-- reset values to default and reloadUI
function ChiEnergyBar:ResetToDefaultValues()

	local noHelpText = ChiEnergyBarDB.noHelpText
	ChiEnergyBarDB = nil
	ChiEnergyBar:LoadDefault()
	if noHelpText then
		ChiEnergyBarDB.noHelpText = true
	end
	ReloadUI()

end

