
-- sorry, monks only
if select(2, UnitClass("player")) ~= "MONK" then
    return
end

local addonName, _ = ...
local version = GetAddOnMetadata("ChiEnergyBar", "Version")
local locDB = ChiEnergyBar.locDB

---------------------------------------------------------------------------------------------
-------------------------[[  Options panel dropdown constructors  ]]-------------------------
---------------------------------------------------------------------------------------------

function ChiEnergyBar:CreateDDHeaderFrame(frName, frTxt, parentPanel, width, height, xPos, yPos)

	local frName, frTxt, parentPanel, height = frName, frTxt, parentPanel, height
	local xPos, yPos = xPos, yPos
	local frTitle = "ChiEnergyBar_"..frName.."TitleFrame"
	local ddFr = "ChiEnergyBar_"..frName.."List"
	local ddBgFr = "ChiEnergyBar_"..frName.."DdBg"
	local titleArrow = "ChiEnergyBar_"..frName.."TitleFrameExpandArrow"
	local ddTitleFr = CreateFrame("Frame", frTitle, _G[parentPanel])
	ddTitleFr:SetWidth(width)
	ddTitleFr:SetHeight(height)
	ddTitleFr:SetPoint("BOTTOMLEFT", _G[parentPanel], xPos, yPos)
	local bg = {
		bgFile = "Interface\\TutorialFrame\\TutorialFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 8,
		edgeSize = 8,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddTitleFr:SetBackdrop(bg)
	local frTitleStr = _G[frTitle]:CreateFontString(frTitle.."Str", "ARTWORK", "GameFontNormalSmall")
	frTitleStr:SetJustifyH("CENTER")
	frTitleStr:SetPoint("CENTER", frTitle, "CENTER", 0, 0)
	frTitleStr:SetTextColor(1, 1, 1, 1)
	frTitleStr:SetFont("Fonts\\FRIZQT__.TTF", 12)
	frTitleStr:SetText(frTxt)
	local frExpandArrow = CreateFrame("Button", titleArrow, _G[frTitle])
	frExpandArrow:SetWidth(22)
	frExpandArrow:SetHeight(22)
	frExpandArrow:SetPoint("RIGHT", frTitle, -2, 0)
	frExpandArrow:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
	frExpandArrow:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	frExpandArrow:SetScript("OnClick", function(self, button, down)
		if _G[ddFr]:IsVisible() then
			if frName == "ebBorder" then
				ChiEnergyBar_ebFontTitleFrame:Show()
			end
			_G[ddFr]:Hide()
			_G[ddBgFr]:Hide()
		else
			if frName == "ebBorder" then
				ChiEnergyBar_ebFontList:Hide()
				ChiEnergyBar_ebFontDdBg:Hide()
				ChiEnergyBar_ebFontTitleFrame:Hide()
			end
			_G[ddFr]:Show()
			_G[ddBgFr]:Show()
		end
	end)

end

function ChiEnergyBar:CreateDDFrame(frName, db, parentPanel, width, height, yPos)

	local frName, db, parentPanel, width, height = frName, db, parentPanel, width, height
	local xPos, yPos = 0, yPos
	local maxEntries = #locDB[db]
	local frTitle = "ChiEnergyBar_"..frName.."TitleFrame"
	local fr = "ChiEnergyBar_"..frName.."List"
	local ddBg = "ChiEnergyBar_"..frName.."DdBg"
	local ddFr = CreateFrame("Frame", fr, _G[parentPanel])
	ddFr:SetFrameStrata("TOOLTIP")
	ddFr:SetPoint("TOPLEFT", frTitle, xPos, yPos)
	ddFr:SetWidth(width)
	ddFr:SetHeight(height * maxEntries)
	ddFr:Hide()
	local ddBgFr = CreateFrame("Frame", ddBg, _G[parentPanel])
	ddBgFr:SetWidth(width)
	ddBgFr:SetHeight((height * maxEntries) + 8)
	ddBgFr:SetPoint("TOPLEFT", frTitle, xPos, yPos + 5)
	local bg = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 8,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddBgFr:SetBackdrop(bg)
	ddBgFr:Hide()

end

function ChiEnergyBar:CreateDDChild(frName, db, width, height, yPos)

	local frName, db, width, height, yPos = frName, db, width, height, yPos
	local maxEntries = #locDB[db]
	for i = 1, maxEntries do
		local strName = "ChiEnergyBar_"..frName.."Str"
		local btnName = "ChiEnergyBar_"..frName.."Button"
		local frTitle = "ChiEnergyBar_"..frName.."TitleFrame"
		local scrFr = "ChiEnergyBar_"..frName.."List"
		local ddChBtn = CreateFrame("Button", btnName..i, _G[scrFr], nil)
		ddChBtn:EnableMouse(true)
		ddChBtn:SetFrameStrata("TOOLTIP")
		ddChBtn:SetWidth(width)
		ddChBtn:SetPoint("TOPLEFT", frTitle, 4, yPos)
		ddChBtn:SetHeight(height)
		ddChBtn:SetHighlightTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background", "ADD")
		local ddChStr = ddChBtn:CreateFontString(strName..i, "ARTWORK", "GameFontNormal")
		ddChStr:SetJustifyH("CENTER")
		ddChStr:SetPoint("CENTER", ddChBtn, "CENTER", 0, 0)
		ddChStr:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
		ddChStr:SetText(locDB[db][i].txt)
		yPos = yPos - height
	end

end

function ChiEnergyBar:InitializeDD(frName, db, id)

	local frName, db, id = frName, db, id
	local maxEntries = #locDB[db]
	local setMatch = ChiEnergyBarDB[id][db].txt
	for i = 1, maxEntries do
		local ddChStr = "ChiEnergyBar_"..frName.."Str"..i
		local ddChBtn = "ChiEnergyBar_"..frName.."Button"..i
		if locDB[db][i].txt == setMatch then
			_G[ddChBtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
			_G[ddChStr]:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
		else
			_G[ddChBtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Background-Dark")
			_G[ddChStr]:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
		end
	end

end

function ChiEnergyBar:OnClickDD(frName, db, id)

	local frName, db, id = frName, db, id
	local maxEntries = #locDB[db]
	local btnName = "ChiEnergyBar_"..frName.."Button"
	local strName = "ChiEnergyBar_"..frName.."Str"
	for i = 1, maxEntries do
		local btnFr = btnName..i
		local strFr = strName..i
		_G[btnFr]:SetScript("OnClick", function(self, button, down)
			ChiEnergyBar:DDCleaner(frName, db)
			ChiEnergyBar:DDClickedHandler(frName, db, id, strFr, btnFr, i)
		end)
	end

end

function ChiEnergyBar:DDCleaner(frName, db)

	local frName, db = frName, db
	local maxEntries = #locDB[db]
	for i = 1, maxEntries do
		local curBtn = "ChiEnergyBar_"..frName.."Button"..i
		local curStr = "ChiEnergyBar_"..frName.."Str"..i
		_G[curStr]:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
		_G[curBtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Background-Dark")
	end

end

function ChiEnergyBar:DDClickedHandler(frName, db, id, ddChStr, ddChBtn, frNr)

	local frName, db, id = frName, db, id
	local ddChBtn = ddChBtn
	local ddChStr = ddChStr
	local frNr = frNr
	local fHeight = ChiEnergyBarDB.eb.font.height
	ChiEnergyBarDB[id][db] = locDB[db][frNr]
	_G[ddChStr]:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
	_G[ddChBtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
	local bg = {
		bgFile = nil,
		edgeFile = ChiEnergyBarDB[id].border.path,
		tile = false,
		tileSize = 8,
		edgeSize = ChiEnergyBarDB[id].border.edgeSize,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3,
		}
	}
	if id == "eb" then
		if frName == "ebFont" then
			local energyStr = ChiEnergyBar:GetEnergyString()
			local enFont = EnergyBarFont
			enFont:SetFont(ChiEnergyBarDB.eb.font.path, fHeight, "OUTLINE")
			local enText = EnergyBarText
			enText:SetPoint(ChiEnergyBarDB.eb.fontSetPoints.setPoint, ChiEnergyBarDB.eb.fontSetPoints.hPadding, 0)
			enText:SetText(energyStr)
			ChiEnergyBarDB.eb.font.height = fHeight
		elseif frName == "ebFontSetPoints" then
			local enText = EnergyBarText
			local energyStr = ChiEnergyBar:GetEnergyString()
			enText:SetPoint(ChiEnergyBarDB.eb.fontSetPoints.setPoint, ChiEnergyBarDB.eb.fontSetPoints.hPadding, 0)
			enText:SetText(energyStr)
			ReloadUI()
		else
			EnergyBar:SetBackdrop(bg)
			EnergyStatusBar:SetSize(ChiEnergyBarDB[id].size.w - ChiEnergyBarDB[id].border.adjW, ChiEnergyBarDB[id].size.h - ChiEnergyBarDB[id].border.adjH)
			bg.bgFile = ChiEnergyBarDB[id].texture.path
			EbColorPicker:SetBackdrop(bg)
			EbColorPicker:SetBackdropColor(ChiEnergyBarDB.eb.color.r, ChiEnergyBarDB.eb.color.g, ChiEnergyBarDB.eb.color.b, ChiEnergyBarDB.eb.color.a)
		end
	elseif id == "cp" then
		bg.bgFile = ChiEnergyBarDB[id].texture.path
		local cpF = "CPFrame"
		for i = 0, locDB.cpMax - 1 do
			local frIndex = i + 1
			local fr = cpF..frIndex
			_G[fr]:SetBackdrop(bg)
			_G[fr]:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
		end
		CpColorPicker:SetBackdrop(bg)
		CpColorPicker:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
		locDB.cpUpdate = true
		ChiEnergyBar:UpdateBar()
	else
		local tbFont = TBBarFont
		local _, _, _, _, tbCur = ChiEnergyBar:UpdateEnergy()
		tbFont:SetFont(ChiEnergyBarDB.tb.font.path, fHeight, "OUTLINE")
		local tbText = TBBarText
		tbText:SetPoint("CENTER", 0, 0)
		tbText:SetText(tbCur)
		ChiEnergyBarDB.tb.font.height = fHeight
	end

end

---------------------------------------------------------------------------------------------
-------------------------[[  Scrollable dropdownmenuconstructors  ]]-------------------------
---------------------------------------------------------------------------------------------

-- The blizz dropdownmenu closes everytime after making a selection, I don't like this behavior so I create my own ones.
function ChiEnergyBar:MyScrollList_Update(id, scrFr, scrfrname, maxEntries)

	local id, scrFr, scrfrname, maxEntries = id, _G[scrFr], scrfrname, maxEntries
	local line = 1
	local lineplusoffset = 0
	local match = false
	local curStr = ChiEnergyBarDB[id].texture.txt
	local count = #locDB.texture
	FauxScrollFrame_Update(scrFr, count, maxEntries, 18)
	for line = 1, maxEntries do
		local fr = _G["ChiEnergyBar_"..scrfrname.."Button"..line]
		local strFr = _G["ChiEnergyBar_"..scrfrname.."Str"..line]
		lineplusoffset = line + FauxScrollFrame_GetOffset(scrFr)
		if lineplusoffset <= count then
			strFr:SetText(locDB.texture[lineplusoffset].txt)
			fr:SetNormalTexture(locDB.texture[lineplusoffset].path)
			fr:Show()
		else
			fr:Hide()
		end
	end
	for line = 1, maxEntries do
		local strFr = _G["ChiEnergyBar_"..scrfrname.."Str"..line]
		local btnFr = _G["ChiEnergyBar_"..scrfrname.."Button"..line]
		lineplusoffset = line + FauxScrollFrame_GetOffset(scrFr)
		local btnTxt = locDB.texture[lineplusoffset].txt
		if curStr ==btnTxt and match == false then
			strFr:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
			match = true
		else
			strFr:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
		end
	end

end

function ChiEnergyBar:MyFauxScrollFrame_OnVerticalScroll(self, offset, maxEntries, height, scrFrName, id)

	local self, offset, maxEntries, height, scrFrName, id = self, offset, maxEntries, height, scrFrName, id
	local selfName = self:GetName()
	local scrBar = _G[selfName.."ScrollBar"]
	scrBar:SetValue(offset)
	self.offset = floor((offset / height) + 0.5)
	ChiEnergyBar:MyScrollList_Update(id, "ChiEnergyBar_"..scrFrName.."List", scrFrName, maxEntries)

end

function ChiEnergyBar:CreateScrollFrame(scrfrname, id, parentPanel, maxEntries, width, height, yPos)

	local scrfrname, id, parentPanel, maxEntries, width = scrfrname, id, parentPanel, maxEntries, width
	local height = height * maxEntries
	local xPos, yPos = 0, yPos
	local frTitle = "ChiEnergyBar_"..scrfrname.."TitleFrame"
	local scrFr = "ChiEnergyBar_"..scrfrname.."List"
	local ddBg = "ChiEnergyBar_"..scrfrname.."DdBg"
	local ddFr = CreateFrame("ScrollFrame", scrFr, parentPanel, "FauxScrollFrameTemplate")
	ddFr:SetWidth(width)
	ddFr:SetHeight(height)
	ddFr:SetPoint("TOPLEFT", frTitle, xPos + 1, yPos)
	ddFr:Hide()
	ddFr:SetScript("OnShow", function (self)
		ddFr:SetFrameStrata("TOOLTIP")
		ChiEnergyBar:MyScrollList_Update(id, scrFr, scrfrname, maxEntries)
	end)
	ddFr:SetScript("OnVerticalScroll", function(self, offset)
		ChiEnergyBar:MyFauxScrollFrame_OnVerticalScroll(self, offset, maxEntries, 18, scrfrname, id)
	end)
	local ddBgFr = CreateFrame("Frame", ddBg,ddFr)
	ddBgFr:SetFrameStrata("TOOLTIP")
	ddBgFr:SetWidth(width + 28)
	ddBgFr:SetHeight(height + 9)
	ddBgFr:SetPoint("TOPLEFT", frTitle, xPos, yPos + 5)
	local bg = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 8,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddBgFr:SetBackdrop(bg)
	ddBgFr:Hide()

end

function ChiEnergyBar:CreateScrollableDDChild(frName, id, maxEntries, width, height, yPos)

	local frName, id, maxEntries, width, height, yPos = frName, id, maxEntries, width, height, yPos
	local index = 1
	local count = maxEntries
	while count ~= 0 do
		local strname = "ChiEnergyBar_"..frName.."Str"
		local btnName = "ChiEnergyBar_"..frName.."Button"
		local frTitle = "ChiEnergyBar_"..frName.."TitleFrame"
		local scrFr = "ChiEnergyBar_"..frName.."List"
		local ddBtn = CreateFrame("Button", btnName..index, _G[scrFr], nil)
		ddBtn:EnableMouse(true)
		ddBtn:SetHeight(height)
		ddBtn:SetWidth(width + 32)
		ddBtn:SetPoint("TOPLEFT", frTitle, 3, yPos - 2)
		ddBtn:SetNormalTexture(locDB.texture[index].path)
		ddBtn:SetHighlightTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background", "ADD")
		local ddStr = ddBtn:CreateFontString(strname..index, "ARTWORK", "GameFontNormal")
		ddStr:SetJustifyH("CENTER")
		ddStr:SetPoint("CENTER", ddBtn, "CENTER", 1, 0)
		ddStr:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
		ddStr:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
		ddStr:SetText(locDB.texture[index].path)
		ddBtn:SetScript("OnClick", function(self, button, down)
			local btnTxt = ddStr:GetText()
			for i = 1, maxEntries do
				local btnFr = btnName..i
				local strFr = strname..i
				_G[strFr]:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
			end
			ddStr:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
			for i= 1, #locDB.texture do
				if btnTxt == locDB.texture[i].txt then
					ChiEnergyBarDB[id].texture = locDB.texture[i]
					local bg = {
						bgFile = nil,
						edgeFile = ChiEnergyBarDB.eb.border.path,
						tile = false,
						tileSize = 8,
						edgeSize = ChiEnergyBarDB.eb.border.edgeSize,
						insets = {
							left = 3,
							right = 4,
							top = 4,
							bottom = 3,
						}
					}
					if id == "eb" then
						EnergyStatusBarTexture:SetTexture(ChiEnergyBarDB[id].texture.path)
						bg.bgFile = ChiEnergyBarDB.eb.texture.path
						EbColorPicker:SetBackdrop(bg)
						EbColorPicker:SetBackdropColor(ChiEnergyBarDB.eb.color.r, ChiEnergyBarDB.eb.color.g, ChiEnergyBarDB.eb.color.b, ChiEnergyBarDB.eb.color.a)
					else
						local bg = {
							bgFile = ChiEnergyBarDB.cp.texture.path,
							edgeFile = ChiEnergyBarDB.cp.border.path,
							tile = false,
							tileSize = 8,
							edgeSize = ChiEnergyBarDB.cp.border.edgeSize,
							insets = {
								left = 3,
								right = 3,
								top = 3,
								bottom = 3,
							}
						}
						local cpF = "CPFrame"
						for i = 0, locDB.cpMax - 1 do
							local frIndex = i + 1
							local fr = cpF..frIndex
							_G[fr]:SetBackdrop(bg)
							_G[fr]:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
						end
						CpColorPicker:SetBackdrop(bg)
						CpColorPicker:SetBackdropColor(ChiEnergyBarDB.cp.color.r, ChiEnergyBarDB.cp.color.g, ChiEnergyBarDB.cp.color.b, ChiEnergyBarDB.cp.color.a)
					end
				end
			end
			locDB.cpUpdate = true
			ChiEnergyBar:UpdateBar()
		end)
		count = count - 1
		index = index + 1
		yPos = yPos - height
	end

end

---------------------------------------------------------------------------------------------
---------------------[[ Checkbox functions ]]------------------------------------------------
---------------------------------------------------------------------------------------------

function ChiEnergyBar:BarLockToggle(id)

	local isChecked = _G["ChiEnergyBar_"..id.."LockCheckButton"]:GetChecked()
	local msg
	if id == "eb" then
		msg = "Energy bar"
	elseif id == "cp" then
		msg = "Chi points bar"
	else
		msg = "Tigereye brew frame"
	end
	if isChecked then
		_G["ChiEnergyBar_"..id.."LockCheckButton"]:SetChecked(false)
		DEFAULT_CHAT_FRAME:AddMessage(msg.." unlocked")
	else
		_G["ChiEnergyBar_"..id.."LockCheckButton"]:SetChecked(true)
		DEFAULT_CHAT_FRAME:AddMessage(msg.." locked")
	end
	ChiEnergyBar:OnCheckBoxClicked("ChiEnergyBar_"..id.."LockCheckButton", id.."Lock")

end

function ChiEnergyBar:OnCheckBoxClicked(frame, frName)

    local frame, frName = frame, frName
	local isChecked = _G[frame]:GetChecked()
	if isChecked then
		if frName == "ebEnable" then
			ChiEnergyBarDB.ebEnable = true
			if ChiEnergyBarDB.ebShowOnlyInCombat then
				EnergyBar:Hide()
			else
				EnergyBar:Show()
			end
		elseif frName =="cpEnable" then
			ChiEnergyBarDB.cpEnable = true
			if ChiEnergyBarDB.cpShowOnlyInCombat then
				ChiPointsBar:Hide()
			else
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		elseif frName == "tbEnable" then
			ChiEnergyBarDB.tbEnable = true
			if ChiEnergyBarDB.tbShowOnlyInCombat then
				TBBar:Hide()
			else
				TBBar:Show()
			end
		elseif frName == "ebLock" then
			ChiEnergyBarDB.ebLock = true
		elseif frName == "cpLock" then
			ChiEnergyBarDB.cpLock = true
		elseif frName == "tbLock" then
			ChiEnergyBarDB.tbLock = true
		elseif frName == "ebShowOnlyInCombat" then
			ChiEnergyBarDB.ebShowOnlyInCombat = true
			if locDB.inCombat then
				EnergyBar:Show()
			else
				EnergyBar:Hide()
			end
		elseif frName == "cpShowOnlyInCombat" then
			ChiEnergyBarDB.cpShowOnlyInCombat = true
			if locDB.inCombat then
				ChiPointsBar:Show()
			else
				ChiPointsBar:Hide()
			end
		elseif frName == "tbShowOnlyInCombat" then
			ChiEnergyBarDB.tbShowOnlyInCombat = true
			if locDB.inCombat then
				TBBar:Show()
			else
				TBBar:Hide()
			end
		elseif frName == "cpShowAllways" then
			ChiEnergyBarDB.cpShowAllways = true
			if not ChiEnergyBarDB.cpShowOnlyInCombat and ChiEnergyBarDB.cpEnable then
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		elseif frName == "ebShowEnergy"then
			ChiEnergyBarDB.ebShowEnergy = true
			local energyStr = ChiEnergyBar:GetEnergyString()
			EnergyBarText:SetText(energyStr)
		elseif frName == "ebNoMaxEnergy" then
			ChiEnergyBarDB.ebNoMaxEnergy = true
			local energyStr = ChiEnergyBar:GetEnergyString()
			EnergyBarText:SetText(energyStr)
		else
			ChiEnergyBarDB.cpShowAllwaysWithTexture = true
			if not ChiEnergyBarDB.cpShowOnlyInCombat and ChiEnergyBarDB.cpEnable then
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		end
	else
		if frName == "ebEnable" then
			ChiEnergyBarDB.ebEnable = false
			EnergyBar:Hide()
		elseif frName =="cpEnable" then
			ChiEnergyBarDB.cpEnable = false
			ChiPointsBar:Hide()
		elseif frName =="tbEnable" then
			ChiEnergyBarDB.tbEnable = false
			TBBar:Hide()
		elseif frName == "ebLock" then
			ChiEnergyBarDB.ebLock = false
		elseif frName == "cpLock" then
			ChiEnergyBarDB.cpLock = false
		elseif frName == "tbLock" then
			ChiEnergyBarDB.tbLock = false
		elseif frName == "ebShowOnlyInCombat" then
			ChiEnergyBarDB.ebShowOnlyInCombat = false
			if ChiEnergyBarDB.ebEnable == true then
				EnergyBar:Show()
			end
		elseif frName == "cpShowOnlyInCombat" then
			ChiEnergyBarDB.cpShowOnlyInCombat = false
			if ChiEnergyBarDB.cpEnable then
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		elseif frName == "tbShowOnlyInCombat" then
			ChiEnergyBarDB.tbShowOnlyInCombat = false
			if ChiEnergyBarDB.tbEnable then
				TBBar:Show()
			end
		elseif frName == "cpShowAllways" then
			ChiEnergyBarDB.cpShowAllways = false
			if not ChiEnergyBarDB.cpShowOnlyInCombat and ChiEnergyBarDB.cpEnable then
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		elseif frName == "ebShowEnergy"then
			ChiEnergyBarDB.ebShowEnergy = false
			local energyStr = ChiEnergyBar:GetEnergyString()
			EnergyBarText:SetText(energyStr)
		elseif frName == "ebNoMaxEnergy" then
			ChiEnergyBarDB.ebNoMaxEnergy = false
			local energyStr = ChiEnergyBar:GetEnergyString()
			EnergyBarText:SetText(energyStr)
		else
			ChiEnergyBarDB.cpShowAllwaysWithTexture = false
			if not ChiEnergyBarDB.cpShowOnlyInCombat and ChiEnergyBarDB.cpEnable then
				locDB.cpUpdate = true
				ChiEnergyBar:UpdateBar()
				ChiPointsBar:Show()
			end
		end
	end

end

---------------------------------------------------------------------------------------------
---------------------[[ create the Interface Addon Options GUI ]]----------------------------
---------------------------------------------------------------------------------------------

function ChiEnergyBar:CreateOptionsPanel()

	local function CreateTT(owner, anchor, xpos, ypos, msg)

		local owner, anchor, xpos, ypos, msg = owner, anchor, xpos, ypos, msg
		GameTooltip:SetOwner(owner, anchor, xpos, ypos)
		GameTooltip:AddLine(msg, 1, 1, 1)
		GameTooltip:Show()

	end

	local function SetDefaultColor(id)

		local id = id
		local idDb = strlower(id)
		locDB.colPickId = id
		local colPickFr = _G[locDB.colPickId.."ColorPicker"]
		ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a = locDB.color[idDb].r, locDB.color[idDb].g, locDB.color[idDb].b, 1
		colPickFr:SetBackdropColor(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
		if locDB.colPickId == "Eb" then
			EbColorPicker:SetBackdropColor(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
			EnergyStatusBar:SetStatusBarColor(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
		else
			local _, _, cpCur, _ = ChiEnergyBar:UpdateEnergy()
			CpColorPicker:SetBackdropColor(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
			for i = 0, locDB.cpMax - 1 do
				local frIndex = i + 1
				local fr = "CPFrame"..frIndex
				_G[fr]:SetBackdropColor(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
			end
		end
		locDB.cpUpdate = true
		ChiEnergyBar:UpdateBar()

	end

	local function ColPickUpdate(newR, newG, newB, newA)

		local newR, newG, newB, newA = newR, newG, newB, newA
		local colPickFr = _G[locDB.colPickId.."ColorPicker"]
		local idDb = strlower(locDB.colPickId)
		ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g,ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a = newR, newG, newB, newA
		colPickFr:SetBackdropColor(newR, newG, newB, newA)
		if locDB.colPickId == "Eb" then
			EbColorPicker:SetBackdropColor(newR, newG, newB, newA)
			EnergyStatusBar:SetStatusBarColor(newR, newG, newB, newA)
		else
			local _, _, cpCur, _ = ChiEnergyBar:UpdateEnergy()
			CpColorPicker:SetBackdropColor(newR, newG, newB, newA)
			for i = 0, locDB.cpMax - 1 do
				local frIndex = i + 1
				local fr = "CPFrame"..frIndex
				_G[fr]:SetBackdropColor(newR, newG, newB, newA)
			end
			locDB.cpUpdate = true
			ChiEnergyBar:UpdateBar()
		end

	end

	local function CreateDefaultColorButton(id, parent, xPos, yPos)

		local id, parent = id, _G[parent]
		local idDb = strlower(id)
		local button = CreateFrame("Button", id.."ColorDefaultButton", parent, "UIPanelButtonTemplate")
		button:SetWidth(125)
		button:SetHeight(30)
		button:SetPoint("TOPLEFT", parent, xPos, yPos)
		button:SetText("Default color")
		button:SetScript("OnClick", function()
			if ColorPickerFrame:IsVisible() then
				ColorPickerFrame:Hide()
			end
			SetDefaultColor(id)
			locDB.colPickId = id
			ColPickUpdate(ChiEnergyBarDB[idDb].color.r, ChiEnergyBarDB[idDb].color.g, ChiEnergyBarDB[idDb].color.b, ChiEnergyBarDB[idDb].color.a)
		end)
		button:SetScript("OnEnter", function()
			local msg = "Reset to default color"
			CreateTT(button, "ANCHOR_RIGHT", 10, -30, msg)
		end)
		button:SetScript("OnLeave", function()
			GameTooltip:Hide()
		end)

	end

	local function ChiEnergyBar_CreateOptionBackgrounds(frName, parent, width, height, xPos, yPos, bool)

		local frName, parent, width, height, xPos, yPos, bool = frName, parent, width, height, xPos, yPos, bool
		local optBg = CreateFrame("Frame", frName, _G[parent])
		local bg = {
				bgFile = nil,
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				tile = false,
				tileSize = 8,
				edgeSize = 16,
				insets = {
					left = 0,
					right = 0,
					top = 0,
					bottom = 0
				}
			}
		if bool then
			bg = {
				bgFile = "Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal",
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				tile = false,
				tileSize = 8,
				edgeSize = 16,
				insets = {
					left = 3,
					right = 4,
					top = 4,
					bottom = 3
				}
			}
		end
		optBg:SetWidth(width)
		optBg:SetHeight(height)
		optBg:SetBackdrop(bg)
		optBg:SetPoint("TOPLEFT", xPos, yPos)

	end

	local function ChiEnergyBar_CreateOptionHeaders(panel, frName, title)

		local panel, frName, title = panel, frName, title
		frName = "ChiEnergyBar_"..frName.."Bg"
 		local optBg = ChiEnergyBar_CreateOptionBackgrounds(frName, panel, 420, 60, 20, -10, true)
		local optPanel = _G[frName]:CreateFontString(nil, "ARTWORK", "GameFontRedLarge")
		local optIcon = _G[frName]:CreateTexture("ChiEnergyBarIcon", "ARTWORK", UIParent)
		local optTitle = _G[frName]:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		optIcon:SetTexture("interface\\pvprankbadges\\pvprank14")
		optIcon:SetPoint("TOPLEFT", 20, -11)
		optPanel:SetPoint("TOPLEFT", 60, -16)
		local font = "Fonts\\FRIZQT__.TTF"
		local fHeight = 32
		local msgFont = optPanel:SetFont(font, fHeight, "OUTLINE")
		optPanel:SetTextColor(locDB.color.orangeRed.r, locDB.color.orangeRed.g, locDB.color.orangeRed.b, 1)
		optPanel:SetText(addonName.." v"..version)
		optPanel:SetPoint("CENTER", 0, -65)
		local msgFont = optTitle:SetFont(font, 24, "OUTLINE")
		optTitle:SetTextColor(locDB.color.blizzYellow.r, locDB.color.blizzYellow.g, locDB.color.blizzYellow.b, 1)
		optTitle:SetText(title)
		optTitle:SetPoint("CENTER", 0, -57)

	end

	local function SetCheckBox(frName, frame)

		local frName, frame = frName, frame
		if ChiEnergyBarDB[frName] then
			_G[frame]:SetChecked(true)
		else
			_G[frame]:SetChecked(false)
		end

	end

	local function CreateOptionPanelCheckBox(frName, parent, text, xPos, yPos)

		local frName, parent, text, xPos, yPos = frName, parent, text, xPos, yPos
		local frame = "ChiEnergyBar_"..frName.."CheckButton"
		local chkBox = CreateFrame("CheckButton", frame, _G[parent], "ChatConfigCheckButtonTemplate")
		local chkBoxTxt = frame.."Text"
		chkBox:SetPoint("TOPLEFT", parent, xPos, yPos)
		_G[chkBoxTxt]:SetFont("Fonts\\FRIZQT__.TTF", 12)
		_G[chkBoxTxt]:SetText(text)
		SetCheckBox(frName, frame)
		chkBox:SetScript("OnClick", function()
			ChiEnergyBar:OnCheckBoxClicked(frame, frName)
		end)

	end

	local function ChiEnergyBar_Panel_Close()

		ChiEnergyBar_ebBorderList:Hide()
		ChiEnergyBar_ebFontList:Hide()
		ChiEnergyBar_ebFontSetPointsList:Hide()
		ChiEnergyBar_ebTextureList:Hide()
		ChiEnergyBar_cpBorderList:Hide()
		ChiEnergyBar_cpTextureList:Hide()
		ChiEnergyBar_ebBorderDdBg:Hide()
		ChiEnergyBar_ebFontDdBg:Hide()
		ChiEnergyBar_ebFontSetPointsDdBg:Hide()
		ChiEnergyBar_ebTextureDdBg:Hide()
		ChiEnergyBar_cpBorderDdBg:Hide()
		ChiEnergyBar_cpTextureDdBg:Hide()
		ColorPickerFrame:Hide()

	end

	local function OptPanel_OkayCloseHandler(frame)

		frame.okay = function (self) ChiEnergyBar_Panel_Close() end
		frame.cancel = function (self) ChiEnergyBar_Panel_Close() end
		frame:SetScript("OnHide", function()
			ChiEnergyBar_ebFontTitleFrame:Show()
			ChiEnergyBar_Panel_Close()
		end)

	end

	local function myColorCallback(restore)

		local newR, newG, newB, newA
		if restore then
			-- The user bailed, we extract the old color from the table created by ShowColorPicker.
			newR, newG, newB, newA = unpack(restore)
		else
			newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB()
		end
		ColPickUpdate(newR, newG, newB, newA)

	end

	local function ShowColorPicker(r, g, b, a, changedCallback)

		ColorPickerFrame:SetColorRGB(r,g,b)
		ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a
		ColorPickerFrame.previousValues = {r,g,b,a}
		ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = changedCallback, changedCallback, changedCallback
		ColorPickerFrame:Hide() -- Need to run the OnShow handler.
		ColorPickerFrame:Show()

	end

	local function CreateColorPicker(id, parent, xPos, yPos)

		local frName = id.."ColorPicker"
		local dbId = strlower(id)
		local parent = _G[parent]
		local colP = CreateFrame("Button", frName, parent)
		local bg = {
			bgFile = ChiEnergyBarDB[dbId].texture.path,
			edgeFile = ChiEnergyBarDB[dbId].border.path,
			tile = false,
			tileSize = 8,
			edgeSize = ChiEnergyBarDB[dbId].border.edgeSize,
			insets = {
				left = 3,
				right = 3,
				top = 3,
				bottom = 3,
			}
		}
		colP:SetWidth(25)
		colP:SetHeight(25)
		colP:SetPoint("TOPLEFT", parent, xPos, yPos)
		colP:SetBackdrop(bg)
		colP:SetBackdropColor(ChiEnergyBarDB[dbId].color.r, ChiEnergyBarDB[dbId].color.g, ChiEnergyBarDB[dbId].color.b, ChiEnergyBarDB[dbId].color.a)
		local colPStr = colP:CreateFontString(frName.."String", "ARTWORK")
		colPStr:SetJustifyH("CENTER")
		colPStr:SetPoint("CENTER", colP, "RIGHT", 65, 0)
		colPStr:SetFont("Fonts\\ARIALN.TTF", 14)
		colPStr:SetTextColor(1, 1, 1, 1)
		colPStr:SetText("Pick background color")
		colP.cancelFunc = function()
			colP:SetColor(ChiEnergyBarDB[dbId].color.r, ChiEnergyBarDB[dbId].color.g, ChiEnergyBarDB[dbId].color.b, ChiEnergyBarDB[dbId].color.a)
		end
		colP:SetScript("OnClick", function()
			locDB.colPickId = id
			ShowColorPicker(ChiEnergyBarDB[dbId].color.r, ChiEnergyBarDB[dbId].color.g, ChiEnergyBarDB[dbId].color.b, ChiEnergyBarDB[dbId].color.a,  myColorCallback)
		end)

	end

	local function CreateSlider(frName, parent, minVal, maxVal, setVal, xPos, yPos)

		local frName, parent, minVal, maxVal, setVal, xPos, yPos = frName, _G[parent], minVal, maxVal, setVal, xPos, yPos
		local slider = CreateFrame("Slider", frName, parent, "OptionsSliderTemplate")
		slider:SetOrientation("HORIZONTAL")
		slider:SetMinMaxValues(minVal, maxVal)
		slider:SetValue(setVal)
		slider:SetPoint("BOTTOMLEFT", xPos, yPos)
		_G[frName.."Low"]:SetText(tostring(minVal))   	-- Sets the left-side slider text.
		_G[frName.."High"]:SetText(tostring(maxVal)) 	-- Sets the right-side slider text.
		slider:Show()
		return slider

	end

	local chiEnergyBarOptPanel = CreateFrame("Frame", "ChiEnergyBar_Panel", UIParent)
	chiEnergyBarOptPanel:Hide()
	chiEnergyBarOptPanel.name = addonName
	OptPanel_OkayCloseHandler(chiEnergyBarOptPanel)

	local ebPanel = CreateFrame("Frame", "ChiEnergyBar_Panel_Energy", chiEnergyBarOptPanel)
	ebPanel:Hide()
	ebPanel.name = "Energy"
	ebPanel.parent = chiEnergyBarOptPanel.name
	OptPanel_OkayCloseHandler(ebPanel)

	local cpPanel = CreateFrame("Frame", "ChiEnergyBar_Panel_Chi", chiEnergyBarOptPanel)
	cpPanel:Hide()
	cpPanel.name = "Chi"
	cpPanel.parent = chiEnergyBarOptPanel.name
	OptPanel_OkayCloseHandler(cpPanel)

	local tbPanel = CreateFrame("Frame", "ChiEnergyBar_Panel_TB", chiEnergyBarOptPanel)
	tbPanel:Hide()
	tbPanel.name = "TB"
	tbPanel.parent = chiEnergyBarOptPanel.name
	OptPanel_OkayCloseHandler(tbPanel)

	local infoPanel = CreateFrame("Frame", "ChiEnergyBar_Panel_Info", chiEnergyBarOptPanel)
	infoPanel:Hide()
	infoPanel.name = "Info"
	infoPanel.parent = chiEnergyBarOptPanel.name
	OptPanel_OkayCloseHandler(infoPanel)

	local mPanel = ChiEnergyBar_CreateOptionHeaders("ChiEnergyBar_Panel", "GeneralOptionsTitle", "General")
	local ePanel = ChiEnergyBar_CreateOptionHeaders("ChiEnergyBar_Panel_Energy", "EnergyOptTitle", "Energy bar")
	local cPanel = ChiEnergyBar_CreateOptionHeaders("ChiEnergyBar_Panel_Chi", "ChiOptTitle", "Chi points bar")
	local tPanel = ChiEnergyBar_CreateOptionHeaders("ChiEnergyBar_Panel_TB", "TBOptTitle", "Tigereye brew")
	local iPanel = ChiEnergyBar_CreateOptionHeaders("ChiEnergyBar_Panel_Info", "InfoOptTitle", "Info")

	local mPanelBg = ChiEnergyBar_CreateOptionBackgrounds("CEBOpt", "ChiEnergyBar_Panel", 460, 160, 20, -95, false)
	local ePanelBg = ChiEnergyBar_CreateOptionBackgrounds("CEBEnergyOpt", "ChiEnergyBar_Panel_Energy", 420, 420, 20, -95, false)
	local cPanelBg = ChiEnergyBar_CreateOptionBackgrounds("CEBChiOpt", "ChiEnergyBar_Panel_Chi", 420, 350, 20, -95, false)
	local tPanelBg = ChiEnergyBar_CreateOptionBackgrounds("CEBTBOpt", "ChiEnergyBar_Panel_TB", 420, 200, 20, -95, false)
	local iPanelBg = ChiEnergyBar_CreateOptionBackgrounds("CEBInfo", "ChiEnergyBar_Panel_Info", 435, 160, 20, -95, false)

	local infoText = CEBInfo:CreateFontString("CEBInfoText", "OVERLAY")
	infoText:SetPoint("TOPLEFT", 15, -30)
	infoText:SetFont("Fonts\\ARIALN.TTF", 14)
	infoText:SetJustifyH("LEFT")
	local txtDB = locDB.helpText
	local msg = txtDB.slashCom..txtDB.tabSpace..txtDB.toggle1..txtDB.tabSpace..txtDB.toggle2..txtDB.tabSpace..txtDB.toggle3..txtDB.mouse1..txtDB.mouse2..txtDB.mouse3
	infoText:SetText(msg)

	local defButton = CreateFrame("Button", "DefaultButton", ChiEnergyBar_Panel, "UIPanelButtonTemplate")
	defButton:SetWidth(125)
	defButton:SetHeight(30)
	defButton:SetPoint("TOPLEFT", ChiEnergyBar_Panel, 165, -210)
	defButton:SetText("Default")
	defButton:SetScript("OnClick", function()
		ChiEnergyBar:ResetToDefaultValues()
	end)
	defButton:SetScript("OnEnter", function()
		local msg = "Reset to default values and reload UI"
		CreateTT(defButton, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	defButton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	ChiEnergyBar:CreateDDHeaderFrame("ebBorder", "Border", "ChiEnergyBar_Panel_Energy", 182, 25, 40, 210)
	ChiEnergyBar:CreateDDHeaderFrame("ebFont", "Font", "ChiEnergyBar_Panel_Energy", 182, 25, 40, 135)
	ChiEnergyBar:CreateDDHeaderFrame("ebFontSetPoints", "Font setpoint", "ChiEnergyBar_Panel_Energy", 182, 25, 230, 135)
	ChiEnergyBar:CreateDDHeaderFrame("ebTexture", "Texture", "ChiEnergyBar_Panel_Energy", 182, 25,  230, 210)
	ChiEnergyBar:CreateDDHeaderFrame("cpBorder", "Border", "ChiEnergyBar_Panel_Chi", 182, 25, 40, 210)
	ChiEnergyBar:CreateDDHeaderFrame("cpTexture", "Texture", "ChiEnergyBar_Panel_Chi", 182, 25, 230, 210)
	ChiEnergyBar:CreateDDHeaderFrame("tbFont", "Font", "ChiEnergyBar_Panel_TB", 182, 25, 40, 310)

	ChiEnergyBar_ebFontSetPointsTitleFrame:EnableMouse(true)
	ChiEnergyBar_ebFontSetPointsTitleFrame:SetScript("OnEnter", function()
		local msg = "Will ReloadUI when clicked"
		CreateTT(ChiEnergyBar_ebFontSetPointsTitleFrame, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	ChiEnergyBar_ebFontSetPointsTitleFrame:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	ChiEnergyBar:CreateDDFrame("ebBorder", "border", "ChiEnergyBar_Panel_Energy", 182, 18, -29)
	ChiEnergyBar:CreateDDFrame("ebFont", "font", "ChiEnergyBar_Panel_Energy", 182, 18, -29)
	ChiEnergyBar:CreateDDFrame("ebFontSetPoints", "fontSetPoints", "ChiEnergyBar_Panel_Energy", 182, 18, -29)
	ChiEnergyBar:CreateDDFrame("cpBorder", "border", "ChiEnergyBar_Panel_Chi", 182, 18, -29)
	ChiEnergyBar:CreateDDFrame("tbFont", "font", "ChiEnergyBar_Panel_TB", 182, 18, -29)

	ChiEnergyBar:CreateDDChild("ebBorder", "border", 174, 18, -28)
	ChiEnergyBar:CreateDDChild("ebFont", "font", 174, 18, -28)
	ChiEnergyBar:CreateDDChild("ebFontSetPoints", "fontSetPoints", 174, 18, -28)
	ChiEnergyBar:CreateDDChild("cpBorder", "border", 174, 18, -28)
	ChiEnergyBar:CreateDDChild("tbFont", "font", 174, 18, -28)

	ChiEnergyBar:InitializeDD("ebBorder", "border", "eb")
	ChiEnergyBar:InitializeDD("ebFont", "font", "eb")
	ChiEnergyBar:InitializeDD("ebFontSetPoints", "fontSetPoints", "eb")
	ChiEnergyBar:InitializeDD("cpBorder", "border", "cp")
	ChiEnergyBar:InitializeDD("tbFont", "font", "tb")

	ChiEnergyBar:OnClickDD("ebBorder", "border", "eb")
	ChiEnergyBar:OnClickDD("ebFont", "font", "eb")
	ChiEnergyBar:OnClickDD("ebFontSetPoints", "fontSetPoints", "eb")
	ChiEnergyBar:OnClickDD("tbFont", "font", "tb")
	ChiEnergyBar:OnClickDD("cpBorder", "border", "cp")

	ChiEnergyBar:CreateScrollFrame("ebTexture", "eb", ChiEnergyBar_Panel_Energy, 10, 154,  18, - 28)
	ChiEnergyBar:CreateScrollFrame("cpTexture", "cp", ChiEnergyBar_Panel_Chi, 10, 154,  18, - 28)

	ChiEnergyBar:CreateScrollableDDChild("ebTexture", "eb", 10, 125, 18, -26)
	ChiEnergyBar:CreateScrollableDDChild("cpTexture", "cp", 10, 125, 18, -26)

	CreateOptionPanelCheckBox("ebEnable", "ChiEnergyBar_Panel", " Enable energy bar", 40, -125)
	CreateOptionPanelCheckBox("ebLock", "ChiEnergyBar_Panel", " Lock energy bar", 270, -125)
	CreateOptionPanelCheckBox("ebShowOnlyInCombat", "ChiEnergyBar_Panel_Energy", " Show energy bar only in combat", 40, -125)
	CreateOptionPanelCheckBox("ebShowEnergy", "ChiEnergyBar_Panel_Energy", " Show energybar text", 40, -150)
	CreateOptionPanelCheckBox("ebNoMaxEnergy", "ChiEnergyBar_Panel_Energy", " Show current energy only", 60, -175)
	CreateOptionPanelCheckBox("cpEnable", "ChiEnergyBar_Panel", " Enable chi points bar", 40, -150)
	CreateOptionPanelCheckBox("cpLock", "ChiEnergyBar_Panel", " Lock chi points bar", 270, -150)
	CreateOptionPanelCheckBox("cpShowOnlyInCombat", "ChiEnergyBar_Panel_Chi", " Show chi points only in combat", 40, -125)
    CreateOptionPanelCheckBox("cpShowAllways", "ChiEnergyBar_Panel_Chi", " Show empty chi points", 40, -150)
	CreateOptionPanelCheckBox("cpShowAllwaysWithTexture", "ChiEnergyBar_Panel_Chi", " Show empty chi points with texture", 60, -175)
	CreateOptionPanelCheckBox("tbEnable", "ChiEnergyBar_Panel", " Enable tigereye brew frame", 40, -175)
	CreateOptionPanelCheckBox("tbLock", "ChiEnergyBar_Panel", " Lock tigereye brew frame", 270, -175)
	CreateOptionPanelCheckBox("tbShowOnlyInCombat", "ChiEnergyBar_Panel_TB", " Show tigereye brew stack only in combat", 40, -125)

	CreateColorPicker("Eb", "ChiEnergyBar_Panel_Energy", 40, -220)
	CreateColorPicker("Cp", "ChiEnergyBar_Panel_Chi", 40, -220)
--	CreateColorPicker("Tb", "ChiEnergyBar_Panel_TB", 40, -220)

	CreateDefaultColorButton("Eb", "ChiEnergyBar_Panel_Energy", 260, -218)
	CreateDefaultColorButton("Cp", "ChiEnergyBar_Panel_Chi", 260, -218)
--	CreateDefaultColorButton("Tb", "ChiEnergyBar_Panel_TB", 260, -218)

	local ebFHSlider = CreateSlider("ebFHSlider", "ChiEnergyBar_Panel_Energy", 8, 32, ChiEnergyBarDB.eb.font.height, 250, 270)
	local ebFHSlText = ChiEnergyBar_Panel_Energy:CreateFontString("EbFHSliderText", "OVERLAY")
	ebFHSlText:SetPoint("BOTTOMLEFT", 80, 272)
	ebFHSlText:SetFont("Fonts\\ARIALN.TTF", 14)
	ebFHSlText:SetJustifyH("LEFT")
	local msg = "Set font height"
	ebFHSlText:SetText(msg)
	_G["ebFHSlider".."Text"]:SetText(ChiEnergyBarDB.eb.font.height.." px")
	ebFHSlider:SetScript("OnValueChanged", function()
		local fHeight = floor(ebFHSlider:GetValue() + 0.5)
		ebFHSliderText:SetText(fHeight.." px")
		EnergyBarFont:SetFont(ChiEnergyBarDB.eb.font.path, fHeight, "OUTLINE")
		ChiEnergyBarDB.eb.font.height = fHeight
	end)

	local cpSlider = CreateSlider("cpSlider", "ChiEnergyBar_Panel_Chi", 0, 25, ChiEnergyBarDB.cp.spacing, 250, 270)
	local cpSlText = ChiEnergyBar_Panel_Chi:CreateFontString("CpSliderText", "OVERLAY")
	cpSlText:SetPoint("BOTTOMLEFT", 40, 272)
	cpSlText:SetFont("Fonts\\ARIALN.TTF", 14)
	cpSlText:SetJustifyH("LEFT")
	local msg = "Pixel distance between chi points"
	cpSlText:SetText(msg)
	_G["cpSlider".."Text"]:SetText(ChiEnergyBarDB.cp.spacing.." px") 	--Sets the "title" text (top-centre of slider)
	cpSlider:SetScript("OnValueChanged", function()
		local spacing = floor(cpSlider:GetValue() + 0.5)
		local cpF = "CPFrame"
		for i = 0, locDB.cpMax - 1 do
			local frIndex = i + 1
			local fr = _G[cpF..frIndex]
			local setPoint = i * (ChiEnergyBarDB.cp.size.h + ChiEnergyBarDB.cp.spacing)
			fr:SetPoint("LEFT", setPoint, 0)
		end
		cpSliderText:SetText(spacing.." px")
		ChiEnergyBarDB.cp.size.w = (ChiEnergyBarDB.cp.size.h * locDB.cpMax) + (spacing * (locDB.cpMax - 1))
		ChiPointsBar:SetSize(ChiEnergyBarDB.cp.size.w, ChiEnergyBarDB.cp.size.h)
		ChiEnergyBarDB.cp.spacing = spacing
	end)

	local tbFHSlider = CreateSlider("tbFHSlider", "ChiEnergyBar_Panel_TB", 8, 32, ChiEnergyBarDB.tb.font.height, 250, 370)
	local tbFHSlText = ChiEnergyBar_Panel_TB:CreateFontString("TBFHSliderText", "OVERLAY")
	tbFHSlText:SetPoint("BOTTOMLEFT", 80, 372)
	tbFHSlText:SetFont("Fonts\\ARIALN.TTF", 14)
	tbFHSlText:SetJustifyH("LEFT")
	local msg = "Set font height"
	tbFHSlText:SetText(msg)
	_G["tbFHSlider".."Text"]:SetText(ChiEnergyBarDB.tb.font.height.." px")
	tbFHSlider:SetScript("OnValueChanged", function()
		local fHeight = floor(tbFHSlider:GetValue() + 0.5)
		tbFHSliderText:SetText(fHeight.." px")
		TBBarFont:SetFont(ChiEnergyBarDB.tb.font.path, fHeight, "OUTLINE")
		ChiEnergyBarDB.tb.font.height = fHeight
	end)


	InterfaceOptions_AddCategory(chiEnergyBarOptPanel)
	InterfaceOptions_AddCategory(ebPanel)
	InterfaceOptions_AddCategory(cpPanel)
	InterfaceOptions_AddCategory(tbPanel)
	InterfaceOptions_AddCategory(infoPanel)

end
